//=============================================================================
// DataManager.h
//=============================================================================
#pragma once
#include <map>

class CMapManager;
class CMapEvent;
class CMapObject;
class TiXmlElement;
//-----------------------------------------------------------------------------
// CDataManager
//-----------------------------------------------------------------------------
class CDataManager
{
private:
	CDataManager(void);
	virtual ~CDataManager(void);

	BOOL	m_bLoadedMapChipGraph;
	BOOL	m_bLoadedCharacterGraph;
public:
	// ANZXȈՉ
	int		m_nHandleMapChip[MAP_CHIP_GRAPH_MAX];
	int		m_nHandleCharacter[CHAR_GRAPH_MAX];

	void ParseMapObject( TiXmlElement* elMapObj, CMapObject *pMapObj );
	void GetMapObjectLocation( int *pX, int *pY, int nEventID, const CMapEvent *pMapEvent );

public:
	static CDataManager *GetInstance( void );

	// }bv Ǎ/폜
	BOOL LoadMapChipGraph( std::map<int, int> &mapInfo );
	void DeleteMapChipGraph( void );

	BOOL LoadMap( int nMapID, CMapManager *pMap );
	BOOL LoadMapEvent( int nMapID, CMapEvent *pMapEvent );


	// LN^GǍ
	BOOL LoadCharacterGraph( void );
	void DeleteCharacterGraph( void );
};

typedef struct {
	int		nMapID;						// }bvID
	BOOL	bLoopAtEdge;				// [Ń[v邩
	int		nChipID[LAYER_CHIP_MAX];	// Ή}bv`bvID
}MapDataInfo;
