//=============================================================================
// Game.h
//=============================================================================
#pragma once
#include <list>

#include "MapManager.h"
#include "Manipulator.h"
#include "PlayerChar.h"
#include "MsgWindow.h"
#include "ScriptManager.h"

class CDrawable;
class CMapObject;
//-----------------------------------------------------------------------------
// CGame
//-----------------------------------------------------------------------------
class CGame
{
private:
	CGame(void);
	virtual ~CGame(void);

protected:
	int				m_nMode;
	CMapManager		m_Map;
	CManipulator	m_Mani;
	CPlayerChar		m_Player;
	CMsgWindow		m_wndMsg;
	CScriptManager	m_ScrMan;
	BOOL			m_bScriptExecuting;	// t[܂ł܂XNvgߎs

	std::list<CDrawable *> m_lstDrawObj;

	void FrameMove_ModeMap( void );
	void ChangeDirToPlayer( CMapObject *pMapObj );

public:
	static CGame *GetInstance( void );

	BOOL Initialize( void );
	void Finalize( void );

	void FrameMove( void );
	void Render( void );

	void StartScript( CMapObject *pMapObj );
	void ExecOrder( CScriptOrder *pOrder );
	BOOL IsScriptExecuting( void ) const
	{	return m_bScriptExecuting;	};

	CMapManager *GetMapMan( void )
	{	return &m_Map;	};

	// ToDo
	void DEBUG_init( void );
};

