//=============================================================================
// Manipulator.h
//=============================================================================
#pragma once

//-----------------------------------------------------------------------------
// CManipulator
//-----------------------------------------------------------------------------
class CManipulator
{
protected:
	char	m_szKeyBuf[ 256 ];
	DWORD	m_dwKeyPushCnt[ 256 ];
	BOOL	m_bShift;

public:
	CManipulator(void);
	virtual ~CManipulator(void);

	void CheckKeyState( void )
	{
		GetHitKeyStateAll( m_szKeyBuf );
		for ( int iCnt = 0; iCnt < 256; iCnt ++ )
		{
			if ( m_szKeyBuf[iCnt] == 0 )
			{
				m_dwKeyPushCnt[iCnt] = 0;
			}
			else
			{
				m_dwKeyPushCnt[iCnt] ++;
			}
		}
	}
	BOOL IsAnyKeyPushed( void ) const
	{
		for ( int iCnt = 0; iCnt < 256; iCnt ++ )
		{
			if ( m_szKeyBuf[iCnt] )
			{
				return TRUE;
			}
		}
		return FALSE;
	}
	BOOL IsKeyPushed( int nKeyCode ) const
	{	return m_szKeyBuf[nKeyCode];	};
	DWORD GetKeyPushCnt( int nKeyCode ) const
	{	return m_dwKeyPushCnt[nKeyCode];	};

	BOOL CheckKey( int nKeyCode ) const
	{	return (m_dwKeyPushCnt[nKeyCode] == 1 );	};

	BOOL IsShift( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LSHIFT] || m_szKeyBuf[KEY_INPUT_RSHIFT];	};
	BOOL IsAlt( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LALT] || m_szKeyBuf[KEY_INPUT_RALT];	};
	BOOL IsCtr( void ) const
	{	return m_szKeyBuf[KEY_INPUT_LCONTROL] || m_szKeyBuf[KEY_INPUT_RCONTROL];	};
};
