//=============================================================================
// MapEvent.cpp
//=============================================================================
#include "Stdinc.h"
#include "MapEvent.h"
#include "MapObject.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMapEvent::CMapEvent(void)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMapEvent::~CMapEvent(void)
{
	Clear();
}

//-----------------------------------------------------------------------------
// Clear
//-----------------------------------------------------------------------------
void CMapEvent::Clear( void )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj )
		{
			delete pMapObj;
			pMapObj = NULL;
		}
		++it;
	}

	m_lstMapObj.clear();
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CMapEvent::FrameMove( CMapManager *pMapMan )
{
	using namespace std;
	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj )
		{
			pMapObj->FrameMove( pMapMan );
		}
		++it;
	}
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CMapEvent::Render( int nLocX, int nLocY, int iStartX, int iStartY, int nDrawOffsetX, int nDrawOffsetY  )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		// ͈͓`FbN
		if ( pMapObj->GetLocationX() == nLocX && pMapObj->GetLocationY() == nLocY )
		{
			int iPosX = (nLocX - iStartX) * MAP_CHIP_SIZE - ( MAP_CHIP_SIZE / 2 );
			int iPosY = (nLocY - iStartY) * MAP_CHIP_SIZE - ( ONE_CHAR_HEIGHT - MAP_CHIP_SIZE ); 

			pMapObj->SetPos( iPosX + nDrawOffsetX, iPosY + nDrawOffsetY );
			pMapObj->Render();
			return;
		}
		++it;
	}
}
//-----------------------------------------------------------------------------
// GetMapObject
//-----------------------------------------------------------------------------
CMapObject *CMapEvent::GetMapObject( int nLocX, int nLocY )
{
	using namespace std;

	list<CMapObject *>::iterator it = m_lstMapObj.begin();
	while( it != m_lstMapObj.end() )
	{
		CMapObject *pMapObj = (*it);
		if ( pMapObj->GetLocationX() == nLocX && pMapObj->GetLocationY() == nLocY )
		{
			return pMapObj;
		}
		++it;
	}

	return NULL;
}