//=============================================================================
// MapObject.cpp
//=============================================================================
#include "Stdinc.h"
#include "MapObject.h"
#include "MapManager.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMapObject::CMapObject(void)
	: m_lpScript( NULL ), m_nNextMoveFrameCnt( 0 )
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMapObject::~CMapObject(void)
{
	if ( m_lpScript )
	{
		delete [] m_lpScript;
		m_lpScript = NULL;
	}
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
BOOL CMapObject::Create( int nLocX, int nLocY )
{
	m_nLocX = nLocX;
	m_nLocY = nLocY;

	BOOL bRet = TRUE;
	bRet &= CCharacterObject::Create( m_nID, m_nPicID );

	return bRet;
}
//-----------------------------------------------------------------------------
// XV
//-----------------------------------------------------------------------------
void CMapObject::FrameMove( CMapManager *pMapMan )
{
	if ( m_nMoveType == MOVE_TYPE_RANDOM )
	{	// _ړ

		if ( 0 < m_nMoveFrameCnt )
		{	// ĂƂ

			int iNewOffsetX = (int)( MAP_CHIP_SIZE * (double)m_nMoveFrameCnt / GetMoveSpeedFrame() );
			if ( m_nDrawOffsetX < 0 )
			{
				m_nDrawOffsetX = -iNewOffsetX;
			}
			else if ( 0 < m_nDrawOffsetX )
			{
				m_nDrawOffsetX = iNewOffsetX;
			}
			int iNewOffsetY = (int)( MAP_CHIP_SIZE * (double)m_nMoveFrameCnt / GetMoveSpeedFrame() );
			if ( m_nDrawOffsetY < 0 )
			{
				m_nDrawOffsetY = -iNewOffsetY;
			}
			else if ( 0 < m_nDrawOffsetY )
			{
				m_nDrawOffsetY = iNewOffsetY;
			}
			// p^[Gݒ
			m_nState = ( (abs(m_nDrawOffsetX) + abs(m_nDrawOffsetY) ) % MAP_CHIP_SIZE) / 4;
			-- m_nMoveFrameCnt;

			//printf("Offset: (%d,%d)\n", m_nDrawOffsetX, m_nDrawOffsetY );
			return;
		}

		if ( 0 < m_nNextMoveFrameCnt )
		{	// ܂Ȃ
			-- m_nNextMoveFrameCnt;
			return;
		}

		int nDirection = GetRandomMoveDir();
		// ړ`FbN܂ł̑҂Ԑݒ
		m_nNextMoveFrameCnt = GetMoveFreqFrame();
		m_nNextMoveFrameCnt += GetRand( 60 * 1 );	// 1b_

		if ( nDirection == DIRECTION_MAX )
		{
			// printf("Ȃ\n");
			return;	// Ȃ
		}

		// ʍstO`FbN
		int iX, iY;
		pMapMan->GetNewLoc( &iX, &iY, m_nLocX, m_nLocY, nDirection );
		if ( pMapMan->HitTestTile( iX, iY ) == PASS_FLAG_NO_ENTRY )
		{
			// printf("Ȃ To (%d,%d)\n", iX, iY );
			m_nNextMoveFrameCnt = 0;	// s
			return;	// Ȃ
		}
		// ړJn
		// (m_nLocX, m_nLocY)  nDirection֓̕
		StartMove( m_nLocX, m_nLocY, nDirection, GetMoveSpeedFrame() );
	}
}

//-----------------------------------------------------------------------------
// StartMove
//-----------------------------------------------------------------------------
void CMapObject::StartMove( int nX, int nY, int nDirection, int nMoveFrame )
{
	int nNewLocX, nNewLocY;

	if ( !CMapManager::GetNewLoc( &nNewLocX, &nNewLocY, nX, nY, nDirection ) )
	{	// Ȃ
		return;
	}

	// ړݒ
	m_nLocX = nNewLocX;
	m_nLocY = nNewLocY;

	m_nMoveFrameCnt = nMoveFrame;
	m_nDirection = nDirection;

	m_nDrawOffsetX = m_nDrawOffsetY = 0;

	switch ( nDirection )
	{
	case DIRECTION_D:
		m_nDrawOffsetY = -MAP_CHIP_SIZE;
		break;
	case DIRECTION_U:
		m_nDrawOffsetY = MAP_CHIP_SIZE;
		break;
	case DIRECTION_R:
		m_nDrawOffsetX = -MAP_CHIP_SIZE;
		break;
	case DIRECTION_L:
		m_nDrawOffsetX = MAP_CHIP_SIZE;
		break;
	}

}
//-----------------------------------------------------------------------------
// GetRandomMoveDir
//-----------------------------------------------------------------------------
int CMapObject::GetRandomMoveDir( void )
{
	int iDir = GetRand( DIRECTION_MAX );
	return iDir;
}

//-----------------------------------------------------------------------------
// [static] GetMoveType
//-----------------------------------------------------------------------------
int CMapObject::GetMoveType( const char *pText ) 
{
	if ( !pText )
		return MOVE_TYPE_FIXED;

	if ( !strcmp( pText, "RANDOM" ) )
		return MOVE_TYPE_RANDOM;
	else if ( !strcmp( pText, "RANDOM" ) )
		return MOVE_TYPE_FIXED;

	return MOVE_TYPE_FIXED;
}
//-----------------------------------------------------------------------------
// [static] GetMoveFreq
//-----------------------------------------------------------------------------
int CMapObject::GetMoveFreq( const char *pText )
{
	if ( !pText )
		return MOVE_FREQ_NORMAL;


	if ( !strcmp( pText, "NORMAL" ) )
		return MOVE_FREQ_NORMAL;
	else if ( !strcmp( pText, "HIGH" ) )
		return MOVE_FREQ_HIGH;
	else if ( !strcmp( pText, "LOW" ) )
		return MOVE_FREQ_LOW;

	return MOVE_FREQ_NORMAL;
}
//-----------------------------------------------------------------------------
// GetMoveFreqFrame
//-----------------------------------------------------------------------------
int CMapObject::GetMoveFreqFrame( void )
{
	switch ( m_nMoveFreq )
	{
	case MOVE_FREQ_LOW:
		return 60 * 4;	// 4b1
	case MOVE_FREQ_NORMAL:
		return 60;		//	1b1
	case MOVE_FREQ_HIGH:
		return 30;		//  30b1
	}

	return 60;
}
//-----------------------------------------------------------------------------
// [static] GetMoveSpeed
//-----------------------------------------------------------------------------
int CMapObject::GetMoveSpeed( const char *pText )
{
	if ( !pText )
		return MOVE_SPEED_NORMAL;

	if ( !strcmp( pText, "NORMAL" ) )
		return MOVE_SPEED_NORMAL;
	else if ( !strcmp( pText, "HIGH" ) )
		return MOVE_SPEED_HIGH;
	else if ( !strcmp( pText, "LOW" ) )
		return MOVE_SPEED_LOW;

	return MOVE_SPEED_NORMAL;
}
//-----------------------------------------------------------------------------
// GetMoveSpeedFrame
//-----------------------------------------------------------------------------
int CMapObject::GetMoveSpeedFrame( void )
{
	switch ( m_nMoveSpeed )
	{
	case MOVE_SPEED_LOW:
		return 32;
	case MOVE_SPEED_NORMAL:
		return 16;
	case MOVE_SPEED_HIGH:
		return 8;
	}

	return 16;
}

//-----------------------------------------------------------------------------
// [static] GetType
//-----------------------------------------------------------------------------
int CMapObject::GetType( const char *pText ) 
{
	if ( !pText )
		return MAP_OBJECT_TYPE_NPC;

	if ( !strcmp( pText, "NPC" ) )
		return MAP_OBJECT_TYPE_NPC;
	else if ( !strcmp( pText, "STORE" ) )
		return MAP_OBJECT_TYPE_STORE;

	return MAP_OBJECT_TYPE_NPC;
}
//-----------------------------------------------------------------------------
// [static] GetScriptTriger
//-----------------------------------------------------------------------------
int CMapObject::GetScriptTriger( const char *pText )
{
	if ( !pText )
		return MAP_SCRIPT_TRIGER_NONE;

	if ( !strcmp( pText, "BUTTON" ) )
		return MAP_SCRIPT_TRIGER_BUTTON;
	else if ( !strcmp( pText, "ADJOINING" ) )
		return MAP_SCRIPT_TRIGER_ADJOINING;

	return MAP_SCRIPT_TRIGER_NONE;
}
