//=============================================================================
// MsgWindow.cpp
//=============================================================================
#include "Stdinc.h"
#include "MsgWindow.h"
#include "Manipulator.h"
#include "ScriptManager.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CMsgWindow::CMsgWindow(void)
	:m_bWaitNextMessage( FALSE )
{
	RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );
	RtlZeroMemory( m_szDisplayMsg, sizeof(m_szDisplayMsg) );
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CMsgWindow::~CMsgWindow(void)
{
}
//-----------------------------------------------------------------------------
// Render
//-----------------------------------------------------------------------------
void CMsgWindow::Render( void )
{
	if ( !m_bIsVisible )
		return ;

	CFrameWindow::Render();

	// \
	for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
	{
		int iPosY = m_nPosY + FRAME_TO_STRING_MARGINE_Y + ( iCnt * (DISPLAY_MESSAGE_FONT_SIZE + 4) );

		DrawString( m_nPosX + FRAME_TO_STRING_MARGINE_X, iPosY, m_szDisplayMsg[iCnt], STRING_COLOR );
	}
}
//-----------------------------------------------------------------------------
// FrameMove
//-----------------------------------------------------------------------------
void CMsgWindow::FrameMove( const CManipulator *pMani, CScriptManager *pScrMan /*= NULL*/ )
{
	CFrameWindow::FrameMove();

	if ( !m_bIsVisible )
		return;

	if ( pMani->CheckKey( KEY_INPUT_X ) )
	{
		// \̂ȂȂ
		if ( m_nNeedButtonActCount <= 0 )
		{
			// \XNvg邩`FbN
			if ( !pScrMan )
			{
				ShowWindow( FALSE );
				return;
			}
			CScriptOrder *pOrder = pScrMan->PeekNext();
			if ( !pOrder )
			{
				ShowWindow( FALSE );
				return;
			}
			// ̃XNvg̓bZ[W̍XV
			m_bWaitNextMessage = ( pOrder->nID == SCRIPT_ORDER_TALKING );

			delete pOrder;
			ShowWindow( FALSE );
		}

		SetDispMsgBuff();
		m_nNeedButtonActCount --;
	}
}
//-----------------------------------------------------------------------------
// ShowWindow
//-----------------------------------------------------------------------------
void CMsgWindow::ShowWindow( BOOL bFlag )
{
	CFrameWindow::ShowWindow( bFlag );
	if ( bFlag )
	{
		m_bWaitNextMessage = FALSE;
	}
}

//-----------------------------------------------------------------------------
// SetMessage
// ToDo Âo
//-----------------------------------------------------------------------------
void CMsgWindow::SetMessage( const char *pMsg )
{
	// \n܂ł𕪊ăRs[
	DivCopyToMsgBuf( pMsg );

	// \t𐔂
	m_nNeedButtonActCount = 0;
	const char *pStart = pMsg;
	const char *pPtr = strstr( pStart, "\\t" );
	while ( pPtr )
	{
		m_nNeedButtonActCount++;
		pStart = pPtr+1;
		pPtr = strstr( pPtr+1, "\\t" );
	}

	// \t({^҂) ܂ŕ\̈ɃRs[
	SetDispMsgBuff();
}
//-----------------------------------------------------------------------------
// SetDispMsgBuff
//-----------------------------------------------------------------------------
void CMsgWindow::SetDispMsgBuff( void )
{
	// \t܂łRs[
	if ( m_nNeedButtonActCount )
	{
		for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
		{
			const char *pStart = m_szMsg[iCnt];
			const char *pPtr = strstr( pStart, "\\t" );
			if ( pPtr )
			{	// \t܂ŃRs[
				strncpy_s( m_szDisplayMsg[iCnt], m_szMsg[iCnt], (size_t)(pPtr - pStart) );

				// \t
				char szBuffBefore[DISPLAY_MESSAGE_LEN_MAX];
				char szBuffAfter[DISPLAY_MESSAGE_LEN_MAX];

				strcpy_s( szBuffBefore, m_szDisplayMsg[iCnt] );
				strcpy_s( szBuffAfter,  &m_szMsg[iCnt][pPtr - pStart+1] );
				strcpy_s( m_szMsg[iCnt], szBuffBefore );
				strcat_s( m_szMsg[iCnt], szBuffAfter );
				break;

			}
			else
			{	// ʏ핶Rs[
				strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
			}
		}
	}
	else
	{	// ʏ핶SRs[
		for ( int iCnt = 0; iCnt < DISPLAY_MESSAGE_LINE_MAX; iCnt ++ )
		{
			strcpy_s( m_szDisplayMsg[iCnt], _countof(m_szDisplayMsg[iCnt]), m_szMsg[iCnt] );
		}
	}
}

//-----------------------------------------------------------------------------
// SetMessage
//-----------------------------------------------------------------------------
int CMsgWindow::DivCopyToMsgBuf( const char *pSrc )
{
	RtlZeroMemory( m_szMsg, sizeof(m_szMsg) );

	int nLineCnt = 0;
	const char *pStart = pSrc;
	const char *pPtr = strstr( pSrc, "\\n" );

	while ( pPtr )
	{
		char szBuff[DISPLAY_MESSAGE_LEN_MAX];
		strncpy_s( szBuff, pStart, (size_t)(pPtr - pStart) );

		CopyWidthLimitString( m_szMsg[nLineCnt], szBuff, _countof(m_szMsg[nLineCnt])-1 );

		nLineCnt++;
		pStart = pPtr+2;
		pPtr = strstr( pPtr+2, "\\n" );
	}

	CopyWidthLimitString( m_szMsg[nLineCnt], pStart, _countof(m_szMsg[nLineCnt])-1 );

	return nLineCnt;
}
//-----------------------------------------------------------------------------
// CopyWidthLimitString
//-----------------------------------------------------------------------------
int CMsgWindow::CopyWidthLimitString( char *pDst, const char *pSrc, int nLen )
{
	strncpy_s( pDst, nLen, pSrc, nLen );

	int iStrLen = strlen(pDst);
	for ( int iCnt = iStrLen; 0 < iCnt; iCnt -- )
	{
		int iStrWidth = GetDrawStringWidth( pDst, iStrLen );
		if ( m_nWidth < iStrWidth + FRAME_TO_STRING_MARGINE_X * 2 )
		{	// Eɂ͂ݏoȂ1
			pDst[iCnt] = '\0';
		}

	}

	return 0;
}