//=============================================================================
// ScriptManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "ScriptManager.h"
#include "MapObject.h"


//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CScriptManager::CScriptManager(void)
	: m_pTgtMapObj(NULL)
{
}

//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CScriptManager::~CScriptManager(void)
{
	ClearOrder();
}
//-----------------------------------------------------------------------------
// ClearOrder
//-----------------------------------------------------------------------------
void CScriptManager::ClearOrder( void )
{
	using namespace std;
	// EBhE`
	list<CScriptOrder *>::iterator it = m_lstOrder.begin();
	while( it != m_lstOrder.end() )
	{
		CScriptOrder *pOrder = *it;

		if ( pOrder->pParam3 )
			delete [] pOrder->pParam3;

		if ( pOrder->pParam4 )
			delete [] pOrder->pParam4;

		delete pOrder;
		++it;
	}
	m_lstOrder.clear();
}
//-----------------------------------------------------------------------------
// Start
//-----------------------------------------------------------------------------
CScriptOrder *CScriptManager::Start( CMapObject *pMapObj, int nLastGameMode )
{
	m_nLastGameMode = nLastGameMode;
	m_pTgtMapObj = pMapObj;

	printf("Start Script ----- \n");
	printf("%s\n", pMapObj->GetScript() );
	printf("------------------ \n");

	// 
	ClearOrder();

	if ( !Parse( &m_pNextPos, pMapObj->GetScript() ) )
	{
		CSysError::Msg( "XNvg̓G[ [%s]", pMapObj->GetScript() );
	}

	CScriptOrder *pOrder = m_lstOrder.front();
	m_lstOrder.pop_front();

	return pOrder;
}
//-----------------------------------------------------------------------------
// GetNext
//-----------------------------------------------------------------------------
CScriptOrder *CScriptManager::GetNext( void )
{
	const char *pNewNextPos;
	if ( !Parse( &pNewNextPos, m_pNextPos ) )
	{
		return NULL;
	}

	m_pNextPos = pNewNextPos;

	CScriptOrder *pOrder = m_lstOrder.front();
	m_lstOrder.pop_front();

	return pOrder;
}
//-----------------------------------------------------------------------------
// PeekNext
//-----------------------------------------------------------------------------
CScriptOrder *CScriptManager::PeekNext( void )
{
	const char *pNewNextPos;
	if ( !Parse( &pNewNextPos, m_pNextPos ) )
	{
		return NULL;
	}

	CScriptOrder *pOrder = m_lstOrder.front();
	m_lstOrder.pop_front();
	return pOrder;
}

#pragma warning( disable : 4996 )
//-----------------------------------------------------------------------------
// Parse
// 1s 1
//-----------------------------------------------------------------------------
BOOL CScriptManager::Parse( const char **pNextOrderPos, const char *lpzScript )
{
	// 1so
	const char *pStart = lpzScript;
	const char *pPtr = strstr( pStart, ";" );

	if ( !pPtr )	return FALSE;

	char szBuff[1024];
	//while ( pPtr )
	{
		strncpy( szBuff, pStart, pPtr - pStart );
		szBuff[pPtr - pStart] = '\0';
		Trim( szBuff );

		CScriptOrder *pOrder = GetOrder( szBuff );
		if ( pOrder )
		{
			// Xgɒǉ
			m_lstOrder.push_back( pOrder );
		}
		pStart = pPtr+1;
		pPtr = strstr( pStart, ";" );
		*pNextOrderPos = pStart;
	}
	return TRUE;
}

//-----------------------------------------------------------------------------
// GetOrder
//-----------------------------------------------------------------------------
CScriptOrder *CScriptManager::GetOrder( const char *lpLine )
{

	char *pcDup = strdup( lpLine );
	char *pPtr = strtok( pcDup, " " );

	// ߉
	CScriptOrder *pOrder = new CScriptOrder();

	pOrder->nID = SCRIPT_ORDER_ERROR;

	if ( !strcmp( pPtr, "SPEECH" ) )
	{
		pOrder->nID = SCRIPT_ORDER_SPEECH;
	}
	else if ( !strcmp( pPtr, "TALKING" ) )
	{
		pOrder->nID = SCRIPT_ORDER_TALKING;
	}
	else if ( !strcmp( pPtr, "OPEN_STORE" ) )
	{
		pOrder->nID = SCRIPT_ORDER_OPEN_STORE;
	}
	// p[^
	pPtr = strtok( NULL," " );
	while ( pPtr )
	{
		switch( pOrder->nID )
		{
		case SCRIPT_ORDER_SPEECH:
		case SCRIPT_ORDER_TALKING:
			pOrder->pParam3 = new char[ strlen(pPtr)+1];
			strcpy( pOrder->pParam3, pPtr );
			break;
		case SCRIPT_ORDER_OPEN_STORE:
			break;
		}

		pPtr = strtok( NULL, " " );
	}


	free( pcDup );

	// ߂Ȃꍇ
	if ( pOrder->nID == SCRIPT_ORDER_ERROR )
	{
		delete pOrder;
		return NULL;
	}

	return pOrder;
}

//-----------------------------------------------------------------------------
// Trim
// 󔒁Rg폜
//-----------------------------------------------------------------------------
void CScriptManager::Trim( char *s )
{
    int i;
    int count = 0;

    if ( s == NULL ) {
        return;
    }

	//  Rg폜
	char *pStartPtr = strstr( s, "/*" );	// RgJn
	while ( pStartPtr )
	{
		char *pEndPtr = strstr( pStartPtr, "*/" );	// RgI
		if ( pEndPtr )
		{
			// StartEnd܂ł폜
			char szBuff[1024];
			char szBufAfter[1024];

			strncpy( szBuff, s, pStartPtr - s );
			szBuff[pStartPtr - s] = '\0';
			strcpy( szBufAfter, (pEndPtr+2) );

			// 
			strcat( szBuff, szBufAfter );

			// ㏑
			strcpy( s, szBuff );
		}

		pStartPtr = strstr( s, "/*" );	// RgJn
	}



	//  󔒍폜
    // 񒷂擾
    i = strlen(s);

    // 珇ɋ󔒂łȂʒuT
    while ( --i >= 0 && s[i] == ' ' ) count++;

    // I[NULLt
    s[i+1] = '\0';

    // 擪珇ɋ󔒂łȂʒuT
    i = 0;
    while ( s[i] != '\0' && s[i] == ' ' ) i++;

    strcpy(s, &s[i]);

}