//=============================================================================
// ScriptManager.h
//=============================================================================
#pragma once
#include <list>

class CMapObject;

// XNvg 1
class CScriptOrder
{
public:
	int		nID;		// 
	int		nParam1;	// p[^1
	int		nParam2;	// p[^2
	char	*pParam3;	// p[^3
	char	*pParam4;	// p[^4

	CScriptOrder(void)
		:nID( SCRIPT_ORDER_ERROR ), nParam1(0), nParam2(0),
		pParam3( NULL ), pParam4( NULL )
	{}

	virtual ~CScriptOrder(void)
	{
		if ( pParam3 )
		{	delete pParam3;
			pParam3 = NULL;
		}

		if ( pParam4 )
		{	delete pParam4;
			pParam4 = NULL;
		}
	}

};

class CMapObject;
//-----------------------------------------------------------------------------
// CScriptManager
//-----------------------------------------------------------------------------
class CScriptManager
{
protected:
	const char *m_pNextPos;
	int			m_nLastGameMode;
	CMapObject *m_pTgtMapObj;

	std::list<CScriptOrder *> m_lstOrder;
	void ClearOrder( void );

	char *GetOrderString( const char *pLine );
	CScriptOrder *GetOrder( const char *pOrder );

public:
	CScriptManager(void);
	virtual ~CScriptManager(void);

	int GetLastGameMode( void )
	{	return m_nLastGameMode;	};

	CMapObject *GetTargetMapObject( void )
	{	return m_pTgtMapObj;	};

	CScriptOrder *Start( CMapObject *pMapObj, int nLastGameMode );
	CScriptOrder *GetNext( void );
	CScriptOrder *PeekNext( void );
	BOOL Parse( const char **pNextOrderPos, const char *lpzScript );

	static void Trim( char *s );
};

